from django.db import models
# import math
class University(models.Model):
	name=models.CharField(max_length=200)

class Choice(models.Model):
	choice_name = models.CharField(max_length=200)
	university=models.ForeignKey(University,on_delete=models.CASCADE, related_name='choices')
	capacity = models.IntegerField()
	def __str__(self):
		return self.choice_name

# Null_Choice=Choice.objects.create(choice_name="None",capacity=1000)
# Null_Choice.save()

class Applicant(models.Model):
	choices = models.ManyToManyField(Choice, through='Application', related_name='applicants')
	name = models.CharField(max_length=200)
	alloted_choice = models.ManyToManyField(Choice, through='Allocationcl', related_name='alloted_applicant')
	rank = models.IntegerField()
	university=models.ForeignKey(University,on_delete=models.CASCADE,related_name='applicants')
	def __str__(self):
		return self.name
	def ordered_choices(self):  
	#https://stackoverflow.com/questions/934779/django-order-a-model-by-a-many-to-many-field
		"Return a properly ordered set of choices"
		return self.choices.all().order_by('application__priority')

class Application(models.Model):
	choice = models.ForeignKey(Choice, on_delete=models.CASCADE)
	applicant = models.ForeignKey(Applicant, on_delete=models.CASCADE)
	priority = models.IntegerField()
	class Meta:
		# if you have an inline configured in the admin, this will 
		# make the roles order properly 
		ordering = ['priority'] 


class Allocationcl(models.Model):
	choice = models.ForeignKey(Choice, on_delete=models.CASCADE)
	applicant = models.ForeignKey(Applicant, on_delete=models.CASCADE)
	# priority = models.IntegerField()
	class Meta:
		# if you have an inline configured in the admin, this will 
		# make the roles order properly 
		ordering = ['applicant__rank']
